#include <allegro.h>

#ifndef ISOMETRIC_H
#define ISOMETRIC_H

/**
	draw wire model
	to help testing
	
	the wireFrame fills the cube from iso (0,0,0) to iso (sx, sy, sz),
	with iso (0, 0, 0) positioned at screen (rx, ry)
*/
void drawWireFrame (BITMAP *buffer, int rx, int ry, int sx, int sy, int sz, int color);

int isoToScreenX (float x, float y, float z);
int isoToScreenY (float x, float y, float z);
int isoToScreenZ (float x, float y, float z);

/* transform x, y and z from isometric to screen coordinates and put them in rx, ry */
void isoToScreen (float x, float y, float z, int &rx, int &ry);

/* same as isoToScreen but with floats */
void isoToScreen_f (float x, float y, float z, float &rx, float &ry);

#endif
