#include "layer.h"
#include <string>
#include <vector>

#ifndef MENU_H
#define MENU_H

using namespace std;

class MenuItem
{
public:
	MenuItem (int _action, string _text) : action (_action), text (_text) {}
	int action;
	string text;
};

class Menu : public Layer
{
	private:
		enum { MENU_START, MENU_SETTINGS, MENU_QUIT };
		int selected;
		vector <MenuItem> items;
	public:
		Menu (Engine &e);
		virtual ~Menu();
		virtual void init();
		virtual void draw(BITMAP *buffer);
		virtual void update();
		virtual void handleInput();
		void handleAction (int action);
};

#endif
