#include "layer.h"

#include "button.h"

#ifndef PLAYERCONTROL_H
#define PLAYERCONTROL_H

class Player;
class Sprite;

const int OUTRO_TIME = 100;
const float MAXZ = 150.0;

class PlayerControl : public Layer
{
	private:
		int health; // value from 0 to 100
		int lives;
		int score;
		int targetsRemaining;
		int currentLevel;
		Player *tank;
		Player *chopper;
		Player *current; // either tank or chopper
		void nextLevel();
		void gameOver();
		Button btnCheat;
		int tOutro;
		bool outro;
		Sprite *nextTarget;
	public:
		PlayerControl(Engine &e);
		void decreaseTargets();
		void decreaseLife();
		void playerKilled (Player *n);
		void initGame(); // set lives to 5 etc.
		void initLevel(bool hasChopper, bool hasTank, int _targetsRemaining); // start level
		void initChopper ();
		void initTank ();
		virtual void handleInput();
		virtual void draw (BITMAP *buffer);
		virtual void update();
		Player *getNearestPlayer (float x, float y, float maxrange);
		Player *getChopper () { return chopper; }
		int getCurrentLevel() { return currentLevel; }
};

#endif
