#include "background.h"
#include <assert.h>
#include "color.h"
#include <stdio.h>

static const int TILEW = 64;
static const int TILEH = 64;

Background::Background(Engine &e) : Layer (e)
{
	xofst = 0;
	yofst = 0;
	texture = NULL;
}

void Background::init()
{
	texture = create_bitmap (TILEW, TILEH);
	assert (texture);
	
	clear_to_color (texture, GREY);
	rectfill (texture, 0, 0, TILEW / 2, TILEW / 2, BLACK);
	rectfill (texture, TILEW / 2 + 1, TILEH / 2 + 1, TILEW, TILEW, BLACK);
}

Background::~ Background()
{
	if (texture) destroy_bitmap (texture);
	texture = NULL;
}

void Background::update()
{
	xofst++;
	yofst++;
}

void Background::draw(BITMAP * buffer)
{
	assert (texture);

	for (int x = (xofst % TILEW) - TILEW; x < buffer->w + TILEW; x += TILEW)
	{
		for (int y = (yofst % TILEH) - TILEH; y < buffer->h + TILEH; y += TILEH)
		{
			draw_sprite (buffer, texture, x, y);
		}
	}

}
