#include "floor.h"
#include <assert.h>
#include "color.h"
#include <stdio.h>
#include "engine.h"

Floor::Floor(Engine &e) : Layer (e)
{
}

void Floor::init()
{
	texture = parent.getResources()->getRle ("background");
	assert (texture);
}

Floor::~ Floor()
{
}

void Floor::draw(BITMAP * buffer)
{
	assert (texture);
	
	int xofst = 0;
	int yofst = 0;
	if (viewPort)
	{
		xofst = -viewPort->getXofst();
		yofst = -viewPort->getYofst();
	}
	
	int TILEW = texture->w;
	int TILEH = texture->h;
	
	for (int x = (xofst % TILEW) - TILEW; x < buffer->w + TILEW; x += TILEW)
	{
		for (int y = (yofst % TILEH) - TILEH; y < buffer->h + TILEH; y += TILEH)
		{
			draw_rle_sprite (buffer, texture, x, y);
		}
	}

}
