#include "insults.h"
#include "engine.h"
#include "color.h"

const char *insults[INSULT_NUM] =
{
	"Why don't you bore a hole in yourself and let the sap run out?",
	"The higher a monkey climbs, the more you see of its behind",
	"You're a good example of why some animals eat their young.",
	"Is that all you got? Come on, put some effort in it!",
	"Go and boil your bottom, son of a silly person",
	"Your mother was a hamster and your father smelt of eldiberry",
	"Go away or I shall taunt you a second time",
	"I'll get you even if it is the last thing I'll ever do",
	"My feelings - as usual - I will slaughter you all",
	"My initial assessment is that you will all die",
	"Come to surrender or be burned in your tanks.",
	"You silly monky!",
	"Is that all you got?",
};

Insults::Insults (Engine &e) : Layer (e)
{
	tInsult = MIN_INSULT_TIME + rand() % INSULT_VARIATION_TIME;
	active = false;
	insult = NULL;
	pos = 0;
}

void Insults::draw (BITMAP *buffer)
{
	if (pos > 0)
	{
		RLE_SPRITE *current = (parent.getPlayerControl()->getCurrentLevel() <= 1) ? fole1 : fole2;
		draw_rle_sprite (buffer, current, buffer->w - pos, buffer->h - current->h);
		
		if (pos == current->w)
		{
			textout_centre_ex (buffer, font, insult, buffer->w / 2, buffer->h - 16, BLACK, WHITE);
		}
	}
}

void Insults::update ()
{
	tInsult--;
	
	if (active)
	{
		pos += 3;
		if (pos > fole1->w) pos = fole1->w;
	}
	if (!active)
	{
		pos -= 3;
		if (pos < 0) pos = 0;
	}
	
	if (tInsult <= 0)
	{
		active = !active;
		if (active)
		{
			tInsult = INSULT_DISPLAY_TIME;
			int item;
			do
			{
				item = rand() % INSULT_NUM;
			} while (insults[item] == insult); // prevent same one twice in a row
			
			insult = insults[item];
			pos = 0;
		}
		else
		{
			tInsult = MIN_INSULT_TIME + rand() % INSULT_VARIATION_TIME;
		}
	}
}

void Insults::init ()
{
	fole1 = parent.getResources()->getRle("FoleTrans1a");	
	fole2 = parent.getResources()->getRle("FoleTrans2a");	
}
