#include "isometric.h"

void drawWireFrame (BITMAP *buffer, int rx, int ry, int sx, int sy, int sz, int color)
{
	int drx[7];
	int dry[7];
	
	isoToScreen (0, 0, sz, drx[0], dry[0]);
	isoToScreen (sx, 0, sz, drx[1], dry[1]);
	isoToScreen (0, sy, sz, drx[2], dry[2]);
	isoToScreen (sx, sy, sz, drx[3], dry[3]);
	isoToScreen (sx, 0, 0, drx[4], dry[4]);
	isoToScreen (0, sy, 0, drx[5], dry[5]);
	isoToScreen (sx, sy, 0, drx[6], dry[6]);
	
	line (buffer, rx + drx[0], ry + dry[0], rx + drx[1], ry + dry[1], color);
	line (buffer, rx + drx[0], ry + dry[0], rx + drx[2], ry + dry[2], color);
	line (buffer, rx + drx[3], ry + dry[3], rx + drx[1], ry + dry[1], color);
	line (buffer, rx + drx[3], ry + dry[3], rx + drx[2], ry + dry[2], color);
	line (buffer, rx + drx[3], ry + dry[3], rx + drx[6], ry + dry[6], color);
	line (buffer, rx + drx[1], ry + dry[1], rx + drx[4], ry + dry[4], color);
	line (buffer, rx + drx[2], ry + dry[2], rx + drx[5], ry + dry[5], color);
	line (buffer, rx + drx[5], ry + dry[5], rx + drx[6], ry + dry[6], color);
	line (buffer, rx + drx[4], ry + dry[4], rx + drx[6], ry + dry[6], color);
}

void isoToScreen (float x, float y, float z, int &rx, int &ry)
{
	rx = (int)(x - y);
	ry = (int)(x * 0.5 + y * 0.5 - z);
}

void isoToScreen_f (float x, float y, float z, float &rx, float &ry)
{
	rx = (x - y);
	ry = (x * 0.5 + y * 0.5 - z);
}

int isoToScreenX (float x, float y, float z)
{
 	return (int)(x - y);
}

int isoToScreenY (float x, float y, float z)
{
	return (int)(x * 0.5 + y * 0.5 - z);
}

int isoToScreenZ (float x, float y, float z)
{
	return (int)(x + y + z);
}
