#include "menu.h"
#include "color.h"
#include "engine.h"

Menu::Menu(Engine & e) : Layer (e), selected (0), items()
{
	items.push_back (MenuItem(MENU_START, "Start"));
	//items.push_back (MenuItem(MENU_SETTINGS, "Settings"));
	items.push_back (MenuItem(MENU_QUIT, "Quit"));
}

Menu::~ Menu() 
{
}

void Menu::draw(BITMAP * buffer)
{
	int y = 100;
	int c = 0;
	for (vector<MenuItem>::iterator i = items.begin(); i != items.end(); ++i)
	{
		textout_ex (buffer, font, i->text.c_str(), buffer->w / 2, y, (c == selected ? RED : YELLOW), -1);
		y += 100;
		c++;
	}
}

void Menu::update()
{
}

void Menu::handleInput()
{
	if (keypressed())
	{
		int c = readkey();
		switch (c >> 8)
		{
			case KEY_LEFT:
			case KEY_UP:
				if (--selected < 0) selected = items.size() - 1;
				break;
			case KEY_DOWN:
			case KEY_RIGHT:
				if (++selected >= items.size()) selected = 0;
				break;
			case KEY_ENTER:
				handleAction (items[selected].action);
				break;
		}
	}
}

void Menu::handleAction(int action)
{
	switch (action)
	{
		case MENU_START:
			parent.stopMenu();
			parent.startGame();
		break;
		case MENU_SETTINGS:
		break;
		case MENU_QUIT:
			parent.shutdown();
		break;
	}
}

void Menu::init()
{
}
